/*--------------------------------------------------------------------------*/
// Program			: Input port 
// Description 	: Detect push button and display to LED
// Filename			: lab0201.c
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#include <reg51.h>	// Header include register for normal MCS-51
sbit led0 = P1^0; 	// Define port for LED at P1.0
sbit led1 = P1^1;		// Define port for LED at P1.1
sbit sw1 = P3^2;		// Define port for input switch at P3.2
sbit sw2 = P3^3;		// Define port for input switch at P3.2
/**********************************************************************/
/****************** Function for delay time ***************************/
/**********************************************************************/
void delay(unsigned int tick)
{
	unsigned int x,y;			// Keep for counter loop  
	for(x=0;x<tick;x++)     // Loop for delay define by tick variable
	{
		for(y=0;y<444;y++);	// Loop for delay 444 time
	}
}
/**********************************************************************/
/************************* Main Program *******************************/
/**********************************************************************/
void main()
{
	sw1 = 1;		// Configuration P3.2 for input port
	sw2 = 1;		// Configuration P3.3 for input port
	while(1)		// Infinite loop
	{
		if(sw1==0)		// Scan input switch at P3.2
		{
			delay(400); // Delay for debounce
			if(sw1==0)  	// Check real push at P3.2?
			{
				led0 = ~led0;	// Toggle status LED at P1.0
			}	
		}  
		if(sw2==0)		// Scan input switch at P3.3
		{
			delay(400);	// Delay for debounce
			if(sw2==0)  		// Check real push at P3.3?
			{
				led1 = ~led1;	// Toggle status LED at P1.1
			}	
		}
	}	
}  
