/*--------------------------------------------------------------------------*/
// Program			: External interrupt 
// Description 	: Detect push button and display to LED
// Filename			: lab0301.c
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#include <reg51.h>	// Header include register for normal MCS-51 
sbit led0 = P1^0;    // Define port for LED at P1.0
sbit led1 = P1^1;		// Define port for LED at P1.1
/**********************************************************************/
/****************** Function for respond INT0 pin *********************/
/**********************************************************************/
void service_EX0(void) interrupt 0
{
	led0 = ~led0;		// toggle logic for drive LED at P1.0
}
/**********************************************************************/
/****************** Function for respond INT pin *********************/
/**********************************************************************/
void service_EX1(void) interrupt 2
{
	led1 = ~led1;		// toggle logic for drive LED at P1.1
}
/**********************************************************************/
/**************************** Main Program ****************************/
/**********************************************************************/
void main()
{
	EX0 = 1;    // Enable external interrupt 0
	EX1 = 1;		// Enable external interrupt 1
	IT0 = 1;    // Detect input at logic change high to low at INT0 pin
	IT1 = 1;		// Detect input at logic change high to low at INT1 pin
	EA = 1;     // Enable global interrupt
	while(1);   // break program and wait external interrupt
}
/******************************** End *********************************/  
