/*--------------------------------------------------------------------------*/
// Program			: Control LED by keyboard 
// Description 	: Wait for command control LED
// Filename			: lab0701.c
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#include <reg51.h>	// Header include register for normal MCS-51
#include <stdio.h>	// Module function serial port communication
sbit led0 = P1^0;  	// Define port for LED at P1.0
sbit led1 = P1^1;		// Define port for LED at P1.1
/**********************************************************************/
/***************** Function Check status LED **************************/
/**********************************************************************/
void display_status_led(void)
{
	if(led0)			// led0="1" ==> LED0 is OFF
	{
		printf("\nLED0==>OFF");		// Display message LED0 is OFF 		
	}
	else         	// led0="0" ==> LED0 is ON
	{
		printf("\nLED0==>ON");	 	// Display message LED0 is ON 	                
	}
	if(led1)  		// led1="1" ==> LED is OFF
	{
		printf("\nLED1==>OFF");		// Display message LED1 is OFF	
	}
	else    			// led1="0" ==> LED is ON
	{
		printf("\nLED1==>ON");		// Display message LED1 is ON                  
	}
	
}
/**********************************************************************/
/**************************** Main Program ****************************/
/**********************************************************************/
void main()
{
	char command=0; 	// For keep command
	SCON = 0x50;	// Configuration for serial port Rx/Tx data
	TMOD = 0x21;	// Timer 1 mode 2(8 bit auto reload for serial baudrate) 
	TH1 = 0xFD;		// Reload value for serial baudrate(9600 bps)
	TL1 = 0xFD;
	TI = 1;			// Hold bit flag TI 
	TR1 = 1;			// Start timer1 for serial port communication
	while(1)		// Infinite loop
	{
		
		puts("\n\n\n/*********************************/");
		puts("\nPush key number 0 for Toggle LED0  ");
		puts("\nPush key number 1 for Toggle LED1  ");
		puts("\n/*********************************/");
		puts("Command:>> ");
		command = getchar(); 	// Wait for command from serial port
		switch(command)         // Compare command
		{
			case	'0' :		led0 = ~led0;   // Toggle logic LED0
		                  display_status_led();	// Display status of LED
		                  break;				
		   case	'1' :		led1 = ~led1;	// Toggle logic LED1
		                  display_status_led();	// Display status of LED
		                  break;
		 	default	 :		printf("\nCommand not Execute!");
		 						display_status_led();	// Display status of LED
		 						break;
		}
	}	
}
/******************************** End *********************************/ 
