/*--------------------------------------------------------------------------*/
// Program			: Read Temp.  
// Description 	: Read Temp. and show result on LCD 
// Filename			: lab0801.c
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#include<reg51.h>				// Header include register of P89C51RD2 
#include<i2c2051.h>					// Inclued for Call function i2c bus communication
#include<lcd2051.h>					// Module function LCD display
#define DS1621_ID 0x90       	// Difine constant for AT24C16 ID
bit flag;   						// for check .5 or .0 
/***********************************************************************************/
/******************************** Initial Start convert ****************************/
/***********************************************************************************/
void ds1621_init() 
{
   i2c_start();					// i2c start condition
   i2c_wrdata(DS1621_ID);     // Write DS1307 ID for connect 
   i2c_wrdata(0xEE);          // Write command convert Temp.
   i2c_stop();						// i2c stop condition
}
/***********************************************************************************/
/******************************** Convert to LCD display ***************************/
/***********************************************************************************/
void temptolcd(unsigned char tempdat)
{
	unsigned	char tempstr[7],i=4;
	bit sign_neg = 0;	// Define bit for Check negative temp and initial zero value   
	//---------------------------Check negative value-----------------------------//
	if(tempdat>=128)	// If temp negative value  
	{
		sign_neg = 1; 	//	Set bit sign_neg for temp negative value 
		tempdat = (tempdat^0xFF)+1;	// Convert temp by 2'complement
	}
	//---------------------------Convert tempdata to ASCII------------------------//
	do 	// do-while loop for convert temp keep to array tempstr
	{		
		tempstr[--i] = (tempdat%10) + '0';	// Convert to ASCII
		tempdat /= 10; 		// Div for Next digit
	}while(tempdat != 0);	// Check Convert success
	//---------------------------Past sign and space------------------------------//
	if(sign_neg)		
	{
		tempstr[--i] = '-';	// Keep negative sign for temp is negative value
	}	
	while(i>0)           // While loop for keep space in address
	{
		tempstr[--i] = 0x20;		// Keep space to array
	}
	//---------------------------Section display .0 and .5------------------------//
	tempstr[4] = '.'; 	// Past "." for dot display on lcd
	if(flag)             // Check decimal point
	{
		tempstr[5] = '5';		// For .5 display 
	}			
	else
	{
		tempstr[5] = '0'; 	// For .5 display
	}
	//---------------------------Stop of string----------------------------------//
	tempstr[6]= 0;					// Push NULL
	//---------------------------Send temp data to LCD---------------------------//
	lcd_puts(0xC5,&tempstr);	// Send temp convert 
}
/***********************************************************************************/
/******************************** Read Temp. from ds1621 ***************************/
/***********************************************************************************/
char read_temp() 
{        
   char datah,datal;	// For keep Temp.
   i2c_start();					// i2c start condition
   i2c_wrdata(DS1621_ID);     // Write DS1307 ID for connect  
   i2c_wrdata(0xAA);				// Write command read Temp.
   i2c_start();					// i2c start condition
   i2c_wrdata(DS1621_ID+1);	// Write DS1307 ID for read data condition
   datah=i2c_rddata();        // Read data to keep datah
   i2c_ACK();						// i2c acknowladge	
   datal=i2c_rddata();			// Read data to keep datal
   i2c_NACK();						// i2c acknowladge
   i2c_stop();               	// i2c stop condition
   if((datal & 0x80)==0x80)   // Check Temp. .5 or .0 keep result by flag variable
   {flag = 1;}   		// For decimal point is .5==> flag =1 else flag = 0
   else{flag = 0;}   
  	return(datah);             // Return Temp.
}
/***********************************************************************************/
/******************************** Show screen display ******************************/
/***********************************************************************************/
void display_screen()
{
	lcd_puts(line1,"DS1621 Read...");
	lcd_puts(line2,"Temp:       C");
}
/***********************************************************************************/
/******************************** Main Program ************************************/
/***********************************************************************************/
void main()
{
   unsigned char temp;
  	lcd_init();              	// Initial for lcd module
	ds1621_init();               // Initial for send command DS1620
	display_screen();                // For display screen at LCD display 
	while(1)							// Infinite loop
	{
		temp = read_temp();	   // Read temp
		temptolcd(temp);  		// Convert and Display temp to LCD 
	}
} 
/***********************************************************************************/






