/*--------------------------------------------------------------------------*/
// Program			: Easy Remote control LED   
// Description 	: Wait for command control LED form Easy remote
// Filename			: lab0901.c
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#include <reg51.h> 	// Header include register for normal MCS-51
#include <lcd2051.h>		// Module function LCD display
#include <sound2051.h>	// Module function generate sound 
#include <remote2051.h>  // Module function detect command form Easy Remote
sbit led0 = P1^0;  	// Define port for LED at P1.0
sbit led1 = P1^1;		// Define port for LED at P1.1
/**********************************************************************/
/***************** Function Check status LED **************************/
/**********************************************************************/
void display_status_led(void)
{
	lcd_clear();	// Clear LCD
	if(led0)			// led0="1" ==> LED0 is OFF
	{
		lcd_puts(line1,"LED0==>OFF");		// Display message LED0 is OFF 		
	}
	else         	// led0="0" ==> LED0 is ON
	{
		lcd_puts(line1,"LED0==>ON");	 	// Display message LED0 is ON 	                
	}
	if(led1)  		// led1="1" ==> LED is OFF
	{
		lcd_puts(line2,"LED1==>OFF");		// Display message LED1 is OFF	
	}
	else    			// led1="0" ==> LED is ON
	{
		lcd_puts(line2,"LED1==>ON");		// Display message LED1 is ON                  
	}
	
}
/**********************************************************************/
/***************** Function for LED0 work *****************************/
/**********************************************************************/
void led0_work(void)
{
	led0 = ~led0;		// LED toggle logic for drive LED at P1.0
	display_status_led();	// Display status LED at LCD display 
	beep();				// Sound beep 1 time
	clear_remote();   // Clear command of remote
}
/**********************************************************************/
/***************** Function for LED1 work *****************************/
/**********************************************************************/
void led1_work(void)
{
	led1 = ~led1;   	// LED toggle logic for drive LED at P1.1
	display_status_led();	// Display status LED at LCD display
	beep();				// Sound beep 1 time
	clear_remote();	// Clear command of remote
}
/**********************************************************************/
/*************************** Main Program *****************************/
/**********************************************************************/
void main()
{
	lcd_init();   		// Initial LCD
	remote_init();    		// Initial Easy Remote
	display_status_led();  	// Initial display status LED at LCD display
	while(1) 			// Infinite loop
	{
		switch(get_remote())   // Get command from Easy Remote by polling
		{
	 	  	case	'a'	:	led0_work();	// Toggle Logic LED0 and display status LED
	   						break;	
			case	'A'	:	led0_work();	// Toggle Logic LED0 and display status LED
	   						break;
		   case	'b'	:	led1_work();	// Toggle Logic LED1 and display status LED
		   					break;
		   case	'B'	:	led1_work();	// Toggle Logic LED1 and display status LED
	   						break;
		}
	}
	            
} 
