/*--------------------------------------------------------------------------*/
// Program			: Control LED by GUI 
// Description 	: Example LED control by GUI build by delphi
// Filename			: lab1101.c
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#include <reg51.h>	// Header include register for normal MCS-51
#include <stdio.h>	// Module function serial port communication
sbit led0 = P1^0;  	// Define port for LED at P1.0
sbit led1 = P1^1;		// Define port for LED at P1.1
unsigned char ser_command=0;	// For keep command character from serial port
/***********************************************************************************/
/************************* Service interrupt serial port ***************************/
/***********************************************************************************/
void service_serial(void) interrupt 4		// Define vector for serial port interrupt
{
	if(RI)  			// Check RI flag(even recieve data)
	{
		ser_command = SBUF;	// Keep character to ser_command
		RI = 0;   	// Clear bit flag RI
	}
	if(TI)			// Check TI flag(even transmit data)
	{
		TI = 0; 		// Clear bit flag TI
	}
}
/**********************************************************************/
/**************************** Main Program ****************************/
/**********************************************************************/
void main()
{
	char command=0; 	// For keep command
	//-------------- Enable interrupt serial port configuration 9600 bps ------------//
	SCON = 0x50;		// Configuration for serial port Rx/Tx data
	TMOD = 0x21;		// Timer 1 mode 2(8 bit auto reload for serial baudrate)
	TH1 = 0xFD;			// Reload value for serial baudrate(9600 bps)
	TL1 = 0xFD;
	EA = 1;				// Enable interrupt all
	ES = 1;           // Enable serial port interrupt
	TR1 = 1;				// Start timer1 for serial port communication
	while(1)				// Infinite loop
	{
		switch(ser_command)		// Check character recieve form serial port
		{
			case	'0'	:	led0 = ~led0;			// Toggle LED0
								SBUF = (P1 & 0x03);	// Send status LED to serial port 	
								ser_command = 0;     // Clear command
								break;
			case	'1'	:	led1 = ~led1;     	// Toggle LED1
								SBUF = (P1 & 0x03); 	// Send status LED to serial port
								ser_command = 0;  	// Clear command
								break;
			case	'r'	:	SBUF = (P1 & 0x03); 	// Send status LED to serial port 
								ser_command = 0;    	// Clear command
								break;  
	 		}
	}	
}
/**s****************************** End *********************************/ 
