/*--------------------------------------------------------------------------*/
// Program			: Module function control LCD display 
// Description 	: Call funtion control LCD display group type 4 bit  
// Filename			: lcd2051.h
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
#define delay_ms(x) lcd_delay(x)
#define lcd_clear() lcd_command(1)
#define lcd_origin() lcd_command(2)
#define line1 0x80
#define line2 0xC0
sbit e = P1^2;					// Bit control Enable recieve data of LCD
sbit rs = P1^3;				// Bit control Command/Data of LCD
/**********************************************************************/
/****************** Function for delay time ***************************/
/**********************************************************************/
void lcd_delay(unsigned int tick)
{
	unsigned int x,y;				// Keep for counter loop  
	for(x=0;x<tick;x++)     	// Loop for delay define by tick variable
	{
		for(y=0;y<444;y++);		// Loop for delay 200 time
	}
}

/*****************************************************************************/
/*********************** Function send Command to LCD 4 Bit ************************/
/*****************************************************************************/
void lcd_command(unsigned char com)	
{
	unsigned char buff;
	buff = com & 0xF0;
	rs = 0;							// Write Command to LCD       	     		
	e = 1;							//	start generate pluse clock LCD
	P1 = (P1 & 0x0F)|buff ;    // Send data to LCD port
	lcd_delay(1);
	e = 0;
	lcd_delay(1);
	
	buff = (com & 0x0F)<<4;
	rs = 0;							// Write Command to LCD       	     		
	e = 1;							//	start generate pluse clock LCD
	P1 = (P1 & 0x0F)|buff ;    // Send data to LCD port
	lcd_delay(1);
	e = 0;
	lcd_delay(1);     
}
/*****************************************************************************/
/*********************** Function send Data to LCD 4 Bit ************************/
/*****************************************************************************/
void lcd_text(unsigned char text)	//write command
{
	unsigned char buff;
	buff = text & 0xF0;
	rs = 1;							// Write Command to LCD       	     		
	e = 1;							//	start generate pluse clock LCD
	P1 = (P1 & 0x0F)|buff ;    // Send data to LCD port
	lcd_delay(1);               	// Delay for send command
	e = 0;
	lcd_delay(1);
	
	buff = (text & 0x0F)<<4;
	rs = 1;							// Write Command to LCD       	     		
	e = 1;							//	start generate pluse clock LCD
	P1 = (P1 & 0x0F)|buff ;    // Send data to LCD port
	lcd_delay(1);
	e = 0;
	lcd_delay(1); 
}
/*****************************************************************************/
/***************** Function show string message ******************************/
/*****************************************************************************/
void lcd_puts(unsigned char line,char *p)
{
	lcd_origin();         // Set origin address of LCD
	lcd_command(line);			// Set address 00H of LCD
	while(*p)                  // Check data pointer = 0?
	{
	 lcd_text(*p);             // Send data to LCD
	 p++;                      // Increase address 1 time 
	}
}
/*****************************************************************************/
/***************** Convet long integer to ascii for display on LCD **********************/
/*****************************************************************************/
/*void lcd_nbyte(unsigned char line,char *p,unsigned char count)
{
	unsigned char m;
	lcd_origin();         		// Set origin address of LCD
	lcd_command(line);			// Set address 00H of LCD
	for(m=0;m<count;m++)
	{
	 		lcd_text(*p++);      // Send data to LCD
	}
}
/****************************************************************************************/
/***************** Convet integer to ascii for display on LCD ***************************/
/****************************************************************************************/
void inttolcd(unsigned char addr,unsigned int value, unsigned char base)
{
	unsigned char index,i=0;
	char string[8],buffer[8]; 
	index = 8;
  	do 
  	{
    	buffer[--index] = '0' + (value % base);
    	if ( buffer[index] > '9') 
    	{
    		buffer[index] += 'A' - '9' - 1;
   	}
   	value /= base;
  	} while (value != 0);

  	do 
  	{
    	string[i] = buffer[index++];
  		i++;
  	} while ( index < 8);
 	string[i] = 0;
 	/*lcd_origin();
 	lcd_command(addr);
 	for(i=0;i<5;i++)
 	{
 		lcd_text(0x20);		
 	}*/
 	lcd_puts(addr,&string);  
}
/*****************************************************************************/
/*********************** Function set initial parameter LCD 4 Bit ******************/
/*****************************************************************************/
void lcd_init()
{
	lcd_delay(500);       	// Delay for initial LCD
	lcd_command(0x33);      // 2 line ,8 bit display ,5*7 dot
	lcd_command(0x32);		// Command set format 4 bit
	lcd_command(0x28);		
	lcd_command(0x0C);      // Display ON , none cursor
	lcd_clear();		// Clear screen
}

