/*--------------------------------------------------------------------------*/
// Program			: Decode command from Easy remote  
// Description 	: receive command from Easy remote to control robot
// Filename			: remote2051.h
// C compiler		: RIDE 51 V6.1
/*--------------------------------------------------------------------------*/
sbit irm_data = P3^2;	// Define port input remote sensor 
unsigned char ir_command=0;	// Define for keep command from Eesy remote
/*****************************************************************************/
/****************** Function Delay for baudrate 1200 *************************/
/*****************************************************************************/
void delay_baud1200()	// Delay baudrate 1200 bps 
{
	unsigned int x,a;		// Keep for counter loop
	for(x=0;x<1;x++)
	{
		for(a=0;a<365/*731*/;a++);	// Loop for delay 833 us 
	}
}
/*****************************************************************************/
/****************** Function Delay for baudrate 1200(for start bit) **********/
/*****************************************************************************/
void start_1200()			// Delay baudrate 1200 while start bit 
{
	unsigned int x,a;		// Keep for counter loop
	for(x=0;x<1;x++)
	{
		for(a=0;a<183/*365*/;a++);	// Loop for delay 416 us 
	}
}
/*****************************************************************************/
/************* Service interrupt routine for receive command ******************/
/*****************************************************************************/
void service_ex0(void) interrupt 0 
{
  unsigned char i;   // Define for counter loop
  if(irm_data==0)    // Check start bit true?
  	{
  		start_1200();  			// Delay for start bit
  		for(i=0;i<8;i++)  		// For loop count 8 time(for receive data 8 bit)
  		{
  			delay_baud1200(); 	// Delay for data 1 bit
  			ir_command = ir_command>>1;	// Shift data bit to right 1 time 
  			if(irm_data)			// If data bit = high 
  			ir_command = ir_command | 0x80;	// Config data bit = "1"
  		}
		delay_baud1200();			// Delay for stop bit
	}
}
/*****************************************************************************/
/************** Function read Command from Easy remote ***********************/
/*****************************************************************************/
unsigned char get_remote(void)
{
	return(ir_command);		// Return command		
}
/*****************************************************************************/
/*********************** Function clear command ******************************/
/*****************************************************************************/
void clear_remote()
{
	ir_command = 0;         // Clear command
}
/*****************************************************************************/
/*********************** Function initial for Easy remote ********************/
/*****************************************************************************/
void remote_init(void)
{
	irm_data = 1;   	// Configuration input P3.2
	EX0 = 1;         	// Enable External interrupt0 	
	IT0 = 1;          // Detect falling edge
	EA = 1;				// Enable interrupt all
}
 
